## loghandler for jabberif
##

import time


class loghandler:
	def __init__(self, config):
		self.__logfile = config['logfile']
		self.__log = open(self.__logfile, 'a', 0)
		self.__file_log('*** server start ***')
		
		self.__alltypes = ['error', 'traceback', 'module', 'info', 'connection', 'inmessage', 'outmessage']
		self.__tofile = eval(config['logtofile'])
		self.__toscreen = eval(config['logtoscreen'])
		self.__colormap = eval(config['colormap'])

		self.__config = config

	def __file_log(self, message):
		self.__log.write(time.strftime("[%x %X]") + ' ' + message + '\n')
	
	def __screen_log(self, message, type):
		color = ''
		if self.__colormap.has_key(type):
			color = self.__colormap[type]
		print self.colorize(message, color)
	
	def log(self, message, type='info'):
		## decode unicode
		message = unicode(message).encode('latin-1', 'replace')
			
		if not type in self.__alltypes:
			self.__screen_log("unknown message type %s" % type, 'error')
			type = 'info'

		if type in self.__tofile:
			self.__file_log(message)
		if type in self.__toscreen:
			self.__screen_log(message, type)
		
	## text colorizer
	def colorize(self, txt, col=''):
		"""Return colorized text"""
		if not self.__config['coloroutput'] or col == '': return txt
		cols = { 'red':1, 'green':2, 'yellow':3, 'blue':4}
		initcode = '\033[;3'
		endcode  = '\033[0m'
		if type(col) == type(1): 
			return initcode + str(col) + 'm' + txt + endcode
		try: return initcode + str(cols[col]) + 'm' + txt + endcode
		except: return txt
		
	## TODO: actually close the logfile .. at some point
	def close(self):
		self.__log.close()

