## amazon plugin for jabberif
##	search amazon for books
##
## written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##
##

import sys
import SOAPpy
from string import join

class amazon_plugin:
	def __init__(self, ph):
		## ph is the plugin handler
		self.ph = ph
		self.name = 'amazon_plugin'

		self.__developers_token = ph.get_config('amazon_developers_token')
		self.__associates_tag = ph.get_config('amazon_associates_tag')

		## init amazon soap proxy
		url = 'http://soap.amazon.com/schemas3/AmazonWebServices.wsdl'
		self.server = SOAPpy.WSDL.Proxy(url)

		## register command showargs
		ph.register_command(self, 'amazon', self.keywordsearch, '[keywords] search in amazon')

	def keywordsearch(self, args):
		##KeywordSearchRequest
		##
		##      keyword  string
		##      page  string
		##      mode  string
		##      tag  string
		##      type  string
		##      devtag  string
		##      sort  string  (optional)
		##      locale  string  (optional, defaults to US)
		##      price  string  (optional)

		data = self.server.KeywordSearchRequest({'keyword': join(args['cmd'][1:], ' '), 'page':'1', 'mode':'books',
		        'tag':self.__associates_tag, 'type':'lite', 'devtag':self.__developers_token, 'sort': '+daterank'})
			

		outs = []
		outs.append("results: "+ data.TotalResults)

		if data.TotalResults > 0:
			for book in [a._asdict() for a in data.Details][:5]:
				if not book.has_key('Authors'):
					book['Authors'] = ['unknown']
				outs.append("\n%s: %s\n%s: %s\n%s: %s\n%s: %s\n%s: %s" %
					('title', book['ProductName'],
					'author[s]', join(book['Authors'], ', '),
					'date', book['ReleaseDate'],
					'asin', book['Asin'],
					'list price', book['ListPrice']))
		
		## send output back to sender
		output = join(outs, '\n')
		self.ph.send_back(args['con'], args['msg'], '\n'+output)
		
