## google plugin for jabberif
##	interface for the google soap api
##
## written by Ben Fuhrmannek <bef@erlangen.ccc.de>
##

import sys
from string import join,strip
import SOAPpy

class google_plugin:
	def __init__(self, ph):
		self.ph = ph
		self.name = 'google_plugin'
		self.__key = ph.get_config('google_key')

		## init soap proxy
		self.server = SOAPpy.SOAPProxy('http://api.google.com/search/beta2', namespace='urn:GoogleSearch')

		ph.register_command(self, 'google', self.google, '[param] search google')

	def __search(self, searchstring, maxresults = 5):
		google_key = self.__key
		soapfalse = SOAPpy.booleanType(0)
		data = self.server.doGoogleSearch( google_key, searchstring, 0, maxresults, soapfalse, '', soapfalse, '', '', '')
		return [node._asdict() for node in data.resultElements]
		
	def google(self, args):
		## reextract params instead of using the pre-parsed from args['cmd']
		wholemsg = strip(args['msg'].getBody())
		search = wholemsg[wholemsg.find(' ')+1:]

		result = self.__search(search)
		outputs = [r['title']+'\n'+r['URL'] for r in result]
		output = join(outputs, '\n\n')
		if output == '':
			output = 'not result'
		self.ph.send_back(args['con'], args['msg'], '\n'+output)
		
